=pod

Module O_T.pm

A component of the checker group of programs for monitoring applications, databases, networks,
all types of servers, and more. By Nova Software, Inc.

Copyright  by Nova Software, Inc. 2018  All rights reserved.  http://www.nova-sw.com

=cut
  package O_T ; our $VERSION = 0.171119; use strict; use warnings; use sigtrap; use O_B 0.170824; use O_M 0.170824; use O_U 0.170824;
use O_L 0.170824; use O_C 0.170824; use O_A 0.170824; use O_R 0.170824; use IO::Socket;  use IO::Select; use POSIX ;  use Net::hostent; use Storable 'dclone';  use Data::Dumper; our $LogAll = -z 'LOG_ALL_TARGETS' ? 1 : 0;   BEGIN { use Exporter (); our @ISA = qw(Exporter); our @EXPORT = qw( ppT qeT grp_qeT ); }
sub ppT { my ($nwT, $uxT, $ejT) = @_; $LogAll = -z 'LOG_ALL_TARGETS' ? 1 : 0; shL( $LogAll ? dyM(54) : dyM(55) ); moT() if $ejT;  my ( $tqT, $mhT ) = iaR();   my ($u3T, $flT) = (0,0); foreach my $svT (sort keys %$nwT) {  next if ($svT eq q1B or $svT eq qjB) ; next if $nwT->{$svT}{hostrange};  if ( $nwT->{$svT}{nolicense} )  {  shL(dyM(0, $svT) )  unless ($uxT-1)%5; next; } $flT++; unless ( $mhT ) { if ( $flT > $tqT  ) {  shL( dyM(1, $tqT ) ) unless ($uxT-1)%10 ;  last; }
} my $bxT = taC(q1B, 'alertcutoff') ; if (xuT($svT, $u3T > $bxT )) { $u3T++ ; } else { $u3T = 0 if $u3T < $bxT ; } siA(d1M.cwM(164, $u3T), q1B) if $u3T == $bxT;  i2U(taC(q1B, 'interstepdelay')) unless taC($svT,'nochecking'); }  tfT(); $nwT = undef;  return ($u3T, $flT); } my $glT = sub { my $qaT = shift ; my $ugT = shift;      local $_;
no strict 'refs';  my $icT = '*'.$qaT.'::DATA';  no warnings;  seek $icT,0,0 or return '';    use warnings;  my $btT = ''; my $rbT = 0;   while (<$icT>) { $rbT = 1 if /^=pod/ ;   if ($rbT) { $rbT = 0 if /^=cut/;   next;  }   s/\r\n$/\n/;  /^__DATA__|^__END__/ and last;   $btT .= $_ ; }     my $ivT = <$icT>;  use strict;  my $pjT = ssU($btT) ;
$ivT =~s/[\r\n]//g;  if ($pjT ne $ivT) { print "$qaT\n$ivT\n$pjT\n"; if ( open DBGFH, ">tmp/$qaT".'.n' )  {  print DBGFH $btT ; close DBGFH;  } else { warn "222 $!" } my $tmp = txB;  if ($qaT =~/^$tmp\w/) { die seM . cwM(10+4, 4)  ;  } } };  {  my %klT = ();   my %djT = ();  my %uaT = ();  my %zsT = ();  my %zgT = (); 
my %ceT = ();   sub xuT { my ($svT, $jrT) = @_; my $hqT = time;  my $gyT = not taC($svT, '_hostbegin') ; my $fbT = $gyT ? dyM(56) : ''; if (taC($svT, 'nochecking') or $gyT) { shL("[$svT] nochecking $fbT"); $klT{$svT} = $djT{$svT} = 0;  $zsT{"[poll_time]$svT"} = 0 - $hqT;  push @{$zsT{$svT}}, [0 - $hqT] unless (ref $zsT{$svT}[-1] and (@{$zsT{$svT}[-1]} == 1));  return 0; } else { push @{$zsT{$svT}[-1]}, $hqT if (ref $zsT{$svT}[-1] and (@{$zsT{$svT}[-1]} == 1));  } my $yvT = taC($svT,'frequency'); if ($yvT) {
if (++$klT{$svT} < 2 ) {}  elsif ($klT{$svT} % $yvT) { shL(dyM(57, $svT, 'frequency'))  if $LogAll; return 0 ; } } else { $klT{$svT} = 0; } my $ufT = taC($svT,'interval'); if ($ufT) { $ufT *= 60;  $djT{$svT} = 0 unless defined $djT{$svT};  if ($hqT >= ($djT{$svT} + $ufT)) { $djT{$svT} = $hqT; } else { unless ($yvT) {  shL(dyM(57, $svT,  'interval' ))  if $LogAll; return 0;
} } } else { $djT{$svT} = 0; } $zsT{"[poll_time]$svT"} = $hqT;  my $gxT = taC($svT,'protocol'); $gxT = lc $gxT;  my $tmp = $gxT.'_t'; no strict 'refs'; my ($juT, $l3T, $fnT, $xmT) = &{$tmp}($svT); use strict; shL($juT); wmL(dyM(58, $fnT, $svT))  if ($l3T > -1 and $fnT > 1); defined $uaT{$svT} or $uaT{$svT} = 0;  my $clT = 0;  if ($l3T < 0) {   if (@{$zsT{$svT}}) {  push @{$zsT{$svT}}, "-$hqT" 
if ( $zsT{$svT}[-1] > 0   or (ref $zsT{$svT}[-1]   and $zsT{$svT}[-1]->[-1] > 0)) ;  } else { $zsT{$svT} = ["-$hqT"];  } if ($uaT{$svT} <= 0) {  $uaT{$svT}--; } else {  $clT = 1; $uaT{$svT} = -1; } if (taC($svT, 'alertdirection') eq 'DOWN') {   my $waT = int (($hqT - abs $zsT{$svT}[-1])/60) ;  alert_slowdown($svT, $waT, $juT, 165, $jrT);  } else {  if ($clT) {
my $waT = int (($hqT - abs $zsT{$svT}[-2])/60) ;  my $cnT = zrB.cwM(169, $svT, $waT) ; shL($cnT); my $qzT = wnA(cwM(170, $svT, $waT ), $cnT , $svT); shL($qzT) if $qzT;    } } } else {  if (@{$zsT{$svT}}) {  push @{$zsT{$svT}}, $hqT  if ( $zsT{$svT}[-1] < 0   or (ref $zsT{$svT}[-1]   and $zsT{$svT}[-1]->[-1] > 0));  } else { $zsT{$svT} = [$hqT];  } if ($uaT{$svT} >= 0) {  $uaT{$svT}++;
} else {  $clT = 1; $uaT{$svT} = 1; } if ( taC($svT, 'alertdirection') eq 'DOWN') { if ($clT) { my $waT = int (($hqT - abs $zsT{$svT}[-2])/60) ;  my $cnT = zrB.cwM(167, $svT, $waT) ; shL($cnT); my $qzT = wnA(cwM(168, $svT, $waT ), $cnT , $svT); shL($qzT) if $qzT;    } } else {  my $waT = int (($hqT - abs $zsT{$svT}[-1])/60) ;  alert_slowdown($svT, $waT, $juT, 171, $jrT);  } } return $l3T < 0 ? 1 : 0;
}  sub raT { my @ixT = keys %klT; while (my $svT = shift @ixT) {  next if ($svT eq q1B or $svT eq qjB) ;  delete $klT{$svT} unless grep (/^$svT$/, @_ ) ; } @ixT = keys %uaT;  while (my $svT = shift @ixT) { next if ($svT eq q1B or $svT eq qjB) ;  delete $uaT{$svT}  unless grep (/^$svT$/ , @_ ) ; } @ixT = keys %djT;  while (my $svT = shift @ixT) { next if ($svT eq q1B or $svT eq qjB) ;  delete $djT{$svT}  unless grep (/^$svT$/ , @_) ; } @ixT = keys %zsT;  while (my $svT = shift @ixT) { next if ($svT eq q1B or $svT eq qjB) ; 
next if $svT =~/\[poll_time\]/;  unless (grep (/^$svT$/ , @_) ) {  delete $zsT{$svT}; delete $zsT{"[poll_time]$svT"}; } } @ixT = keys %ceT;  while (my $svT = shift @ixT) { next if ($svT eq q1B or $svT eq qjB) ;  delete $ceT{$svT}  unless grep (/^$svT$/ , @_) ; }         } sub wpT { my @hcT = keys %zgT;  while (my $gnT = shift @hcT) { next if $gnT =~/\[poll_time\]/;  unless (grep (/^$gnT$/ , @_) ) {  delete $zgT{$gnT}; delete $zgT{"[poll_time]$gnT"}; }
} } sub qeT { $zsT{$_[0]}}  sub grp_qeT {$zgT{$_[0]}} sub moT { %zsT = %zgT = () } sub alert_slowdown{ my ($svT, $waT, $juT, $aiT, $jrT) = @_;  my $fbT = cwM($aiT, $waT);  shL("[$svT] - $fbT"); my $abT = 0; if (taC($svT, 'alertslowdown')) { my $ehT = 1; while ($ehT <= abs $uaT{$svT} ) { if ($ehT == abs $uaT{$svT} ) { $abT = 1; last; } $ehT = int 2.5*$ehT;   } }
else { $abT = 1; } my $rhT = taC($svT,'criticality'); if ($abT and (taC($svT, 'criticality') ne (dxB)[0]) and not $jrT) { my $e1T = wnA("$juT\n$fbT", cwM($aiT + 1, $rhT, $svT, $waT ), $svT); shL($e1T) if $e1T;  } else { shL(dyM(59, $svT, taC(q1B, 'alertcutoff') ) ); } } sub tfT { my $hqT = time();  my $psT = srC(); foreach my $gnT (keys %$psT) { next if $gnT =~/:criticality$/;  $zgT{"[poll_time]$gnT"} = $hqT; foreach my $svT (@{$psT->{$gnT}}) { if ( $zsT{"[poll_time]$svT"} < 0 ) {  $zgT{"[poll_time]$gnT"} = 0 - $hqT;  push@{$zgT{$gnT}}, [0 -$hqT]  
unless ref $zgT{$gnT}->[-1] ;  } } if ($zgT{"[poll_time]$gnT"} < 0 ) {  next;  } else {   push @{$zgT{$gnT}->[-1]}, $hqT   if (ref $zgT{$gnT}->[-1] and   @{$zgT{$gnT}->[-1]} == 1   ); } my $kyT = 0; foreach my $svT (@{$psT->{$gnT}}) { $kyT = 1   if ($zsT{$svT}->[-1] < 0 ) ;  } if (ref $zgT{$gnT}->[-1]) {  push @{$zgT{$gnT}},  $kyT ? 0 - $hqT :  $hqT;   }
elsif (not defined $zgT{$gnT}->[-1]) {  $zgT{$gnT} = $kyT ? [0 - $hqT]  : [$hqT] ; } elsif ($zgT{$gnT}->[-1] > 0 ) {  push @{$zgT{$gnT}},  0 - $hqT if $kyT ;  } elsif ($zgT{$gnT}->[-1] < 0 ) {  push @{$zgT{$gnT}}, $hqT  unless $kyT ;  } } } }  $glT->('O_R');  use O_G 0.170424; our $AUTOLOAD; sub AUTOLOAD { my $svT = shift; my @tmp = split ':', $AUTOLOAD;  $tmp[2] =~s/_t$//; $tmp[2] =~s/\s//g; 
if (my $ciT = O_D::zzD($tmp[2]) ) { my $roT = taC($svT, 'port'); $roT ||= $ciT->[0]; return xbT($svT, $ciT->[1], $roT );  } else {  return (ecM.dyM(48, __PACKAGE__, $AUTOLOAD ),1,0);  } } sub ssU {return crG(shift);}  $glT->('O_C');  sub xbT {   my ($svT, $pnT, $roT ) = @_; return (ecM.dyM(49, __PACKAGE__), 1, 0) unless $svT ;  $pnT = lc $pnT; return (ecM.dyM(50, __PACKAGE__, $pnT) , 1, 0) unless ($pnT eq 'udp' or $pnT eq 'tcp') ; return (ecM.dyM(51, __PACKAGE__, $roT), 1, 0) unless ($roT !~/\D/ and $roT > 0 and $roT < 65536)  ;
my $tyT = taC($svT, '_hostbegin'); my $sgT = taC($svT, 'retry'); $sgT ||= 0;   my $juT = ''; my $bnT = 0; my $l3T = -1;  my $rdT = 0;  my $xmT = time(); my $jxT = '';  my $xwT = ''; my $cuT = taC($svT, 'alertdirection') ; while ($bnT <= $sgT ) {   $bnT++;  my $yaT = IO::Socket::INET->new( PeerAddr    => $tyT, PeerPort    => $roT, Proto       => $pnT, Type        => $pnT eq 'tcp' ? SOCK_STREAM  : SOCK_DGRAM, Timeout     => taC($svT,'connecttimeout'), Blocking    => 1, 
ReuseAddr   => 1,  ); if ($cuT eq 'DOWN') { if ($yaT) { $yaT->autoflush(1); if ($jxT) { $l3T = time() - $jxT; wcC($svT); } else { $l3T = time() - $xmT; } $juT = dyM(60, $svT, $l3T, $tyT, $roT, $pnT, $juT); undef $yaT ;  last; } elsif ($bnT == 1 and taC($svT, 'useip')) { my $knT = taC($svT, 'host'); if ($knT and $tyT ne $knT) { $juT .= dyM(61, $svT, $tyT, $roT, $pnT) ;
$xwT = $tyT; $tyT = $knT; $jxT = time; $sgT++; } } elsif($jxT) { $juT .=dyM(62, $svT, $tyT, $roT, $pnT ) ; last unless $sgT > 1; $jxT = '';  $tyT = $xwT; } } else {  unless ($yaT) {   $rdT = time() - $xmT;  $juT = dyM(64, $svT, $rdT, $tyT, $roT, $pnT, $juT); last; } else { 
$l3T = time() - $xmT; $yaT->autoflush(1); undef $yaT ;  $juT .= dyM(65, $svT, $tyT, $roT, $pnT); last;                   } } select(undef, undef, undef, 0.1);   } if ( $l3T < 0  and ($cuT eq 'DOWN')) { my $cvT = taC($svT, 'criticality'); $rdT = time() - $xmT;  $juT = dyM(63, $cvT, ikB($cvT), $svT, $tyT, $roT, bhB(), $pnT, $bnT, $rdT, $!, $juT) } chomp $juT;  return ($juT, $l3T, $bnT, $xmT); } sub END{ } 1;
__DATA__
yALGNawlf7ECdeY7hv/i9Q

